package de.fitko.fitconnect.core.auth;

import de.fitko.fitconnect.api.domain.auth.OAuthToken;
import de.fitko.fitconnect.api.services.Sender;
import de.fitko.fitconnect.core.SubmissionSender;
import de.fitko.fitconnect.core.auth.DefaultOAuthService;
import org.junit.jupiter.api.Test;
import org.springframework.web.client.RestTemplate;

import java.util.Optional;

import static org.junit.jupiter.api.Assertions.*;

class OAuthTokenIntegrationTest {

    @Test
    void retrieveAuthenticationToken() {

        // Given
        final var tokenUrl = "https://auth-testing.fit-connect.fitko.dev/token";
        final var clientId = "781f6213-0f0f-4a79-9372-e7187ffda98b";
        final var secret = "PnzR8Vbmhpv_VwTkT34wponqXWK8WBm-LADlryYdV4o";
        final var scope1 = "send:region:DE";
        final var scope2 = "send:region:EN";

        final var authService = new DefaultOAuthService(new RestTemplate(), tokenUrl);
        final Sender sender = new SubmissionSender(authService, null, null, null);

        // When
        final OAuthToken token = sender.retrieveOAuthToken(clientId, secret, scope1, scope2);

        // Then
        assertNotNull(token);
        assertNull(token.getError());
        assertNotNull(token.getAccessToken());
        assertEquals(1800, token.getExpiresIn());
    }
}